#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include "lodepng.h"
#include "font.h"

#define SCREEN_W 480
#define SCREEN_H 320
#define SCREENSZ (3 * SCREEN_W * SCREEN_H)
uint8_t       screen[SCREENSZ];
uint16_t      line[SCREEN_W];

struct __attribute__( ( packed ) ) img
{
  uint32_t      addr;
  uint16_t      w;
  uint16_t      h;
};

struct img    Imgs[] = {
  {0x803F6A4, 0x1E0, 0x140},	// 0xc8
  {0x808A808, 7, 0xe},
  {0x808A8CC, 0x14, 0x13},
  {0x808ABC4, 0x14, 0x13},
  {0x808AEBC, 0x14, 0x14},
  {0x808B1DC, 0x14, 0x14},
};

#define nrImg (sizeof(Imgs)/sizeof(struct img))

void
build_screen( FILE * fbin, struct img *I )
{
  uint8_t      *d, r, g, b;
  uint16_t      color;
  int           w, h;

  fseek( fbin, I->addr - 0x8000000, SEEK_SET );
  d = screen;
  for( h = 0; h < I->h; h++ )
  {
    fread( line, sizeof( uint16_t ), I->w, fbin );
    for( w = 0; w < I->w; w++ )
    {
      color = line[w];
      r = ( ( color >> 11 ) & 0x1F ) << 3;
      g = ( ( color >> 5 ) & 0x3F ) << 2;
      b = ( ( color >> 0 ) & 0x1F ) << 3;
      *d++ = r;
      *d++ = g;
      *d++ = b;
    }
  }
}

int
main( int argc, char *argv[] )
{
  FILE         *fbin;
  struct img   *I;
  char          fimg[32];
  int           i;

  if( ( fbin = fopen( "../FW_1_10c_p.org", "rb" ) ) == NULL )
    return -1;
  for( i = 0; i < nrImg; i++ )
  {
    I = &Imgs[i];
    build_screen( fbin, I );
    sprintf( fimg, "img%d.png", i );
    lodepng_encode24_file( fimg, screen, I->w, I->h );
  }
  fclose( fbin );
  return 0;
}
